## atlas-ecmwf 0.44.0

=== atlas_io/CMakeLists.txt ===
# (C) Copyright 2021 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

############################################################################################
# Atlas-IO

cmake_minimum_required( VERSION 3.12 FATAL_ERROR )

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild )

################################################################################
# Initialise project Atlas

project( atlas_io VERSION ${atlas_VERSION} LANGUAGES CXX )

################################################################################
# Required packages

ecbuild_find_package( NAME eckit REQUIRED )

ecbuild_debug( "   eckit_FEATURES : [${eckit_FEATURES}]" )

################################################################################
# Features that can be enabled / disabled with -DENABLE_<FEATURE>

ecbuild_add_option( FEATURE ECKIT_DEVELOP
                    DESCRIPTION "Used to enable new features or API depending on eckit develop branch, not yet in a tagged release"
                    DEFAULT OFF )

set( eckit_HAVE_ECKIT_CODEC 0 )
if( TARGET eckit_codec )
  set( eckit_HAVE_ECKIT_CODEC 1 )
endif()

ecbuild_add_option( FEATURE ECKIT_CODEC
                    DEFAULT ON
                    DESCRIPTION "Use eckit::codec with adaptor"
                    CONDITION eckit_HAVE_ECKIT_CODEC )

################################################################################
# sources

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

ecbuild_add_option( FEATURE WARNING_AS_ERROR
                    DEFAULT OFF
                    DESCRIPTION "Treat compile warning as error" )

if(HAVE_WARNING_AS_ERROR)
  ecbuild_add_cxx_flags("-Werror" NO_FAIL NAME atlas_io_cxx_warning_as_error)
endif()

ecbuild_add_option( FEATURE WARNINGS
                    DEFAULT ON
                    DESCRIPTION "Add warnings to compiler" )

if(HAVE_WARNINGS)
  ecbuild_add_cxx_flags("-Wall" NO_FAIL)
  ecbuild_add_cxx_flags("-Wextra" NO_FAIL)
  ecbuild_add_cxx_flags("-Wno-unused-parameter" NO_FAIL)

endif()

if( CMAKE_CXX_COMPILER_ID STREQUAL Intel )
  ecbuild_add_cxx_flags("-diag-disable=10441" NO_FAIL)   # Deprecated classic compiler
endif()

check_cxx_source_compiles( "#include <cxxabi.h>\n int main() { char * type; int status; char * r = abi::__cxa_demangle(type, 0, 0, &status); }"
    ATLAS_IO_HAVE_CXXABI_H )

test_big_endian( _BIG_ENDIAN )

if( _BIG_ENDIAN )
  set( ATLAS_IO_BIG_ENDIAN    1 )
  set( ATLAS_IO_LITTLE_ENDIAN 0 )
else()
  set( ATLAS_IO_BIG_ENDIAN    0 )
  set( ATLAS_IO_LITTLE_ENDIAN 1 )
endif()

if( HAVE_ECKIT_CODEC )
  ecbuild_info("atlas_io is configured to be an adaptor library which delegates calls to eckit_codec")
  add_subdirectory(eckit_codec_adaptor)
else()
  add_subdirectory( src )
endif()
add_subdirectory( tests )

################################################################################
# Export and summarize

ecbuild_add_resources(
    TARGET atlas_io-others
    SOURCES_PACK
        README.md
        CHANGELOG.md
        LICENSE
)

ecbuild_install_project( NAME Atlas-IO )
ecbuild_print_summary()

=== pluto/CMakeLists.txt ===
# (C) Copyright 2024- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

cmake_minimum_required( VERSION 3.18 FATAL_ERROR )

find_package( ecbuild 3.4 REQUIRED HINTS ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../ecbuild ${CMAKE_CURRENT_SOURCE_DIR}/../../ecbuild )

if( NOT DEFINED atlas_VERSION )
  set( atlas_VERSION 0.0.0 )
endif()

project( pluto VERSION ${atlas_VERSION} LANGUAGES CXX )

set(CMAKE_CXX_STANDARD 17)
set(CMAKE_CXX_STANDARD_REQUIRED ON)

ecbuild_add_option( FEATURE PMR DESCRIPTION "Compatibility with std::pmr in C++" DEFAULT OFF )
set(PLUTO_HAVE_PMR ${HAVE_PMR})

ecbuild_add_option( FEATURE MDSPAN DESCRIPTION "Compatibility with std::mdspan in C++" DEFAULT OFF )
set(PLUTO_HAVE_MDSPAN ${HAVE_MDSPAN})

option(PLUTO_MDSPAN_USE_PAREN_OPERATOR "Enable pluto::mdspan multidimensional paren operator" ON)

find_package(hic QUIET)
if( NOT hic_FOUND )
  add_subdirectory(../hic ${CMAKE_CURRENT_BINARY_DIR}/hic )
  find_package(hic REQUIRED)
endif()

ecbuild_info("pluto found hic: ${hic_DIR}")

set( HAVE_CUDA ${hic_HAVE_CUDA} )
set( HAVE_HIP  ${hic_HAVE_HIP}  )

if( HAVE_CUDA )
  ecbuild_info("pluto has GPU support via hic with CUDA backend")
  set( CMAKE_CUDA_RESOLVE_DEVICE_SYMBOLS ON )
  set( CMAKE_CUDA_SEPARABLE_COMPILATION  ON )
  set( CMAKE_CUDA_STANDARD 17)
  set( CMAKE_CUDA_STANDARD_REQUIRED ON )
  enable_language(CUDA)
elseif( HAVE_HIP )
  ecbuild_info("pluto has GPU support via hic with HIP backend")
  set(CMAKE_HIP_STANDARD 17)
  set(CMAKE_HIP_STANDARD_REQUIRED ON)
  enable_language(HIP)
else()
  ecbuild_info("pluto has no GPU support")
endif()

ecbuild_add_option( FEATURE WARNINGS  DESCRIPTION "Add warnings to compiler"   DEFAULT ON  )
if(HAVE_WARNINGS)
  ecbuild_add_cxx_flags("-Wall"      NO_FAIL NAME pluto_cxx_Wall QUIET)
  ecbuild_add_cxx_flags("-Wextra"    NO_FAIL NAME pluto_cxx_Wextra QUIET)
  ecbuild_add_cxx_flags("-Wpedantic" NO_FAIL NAME pluto_cxx_Wpedantic QUIET)
endif()

ecbuild_add_option( FEATURE WARNING_AS_ERROR
                    DEFAULT OFF
                    DESCRIPTION "Treat compile warning as error" )
if(HAVE_WARNING_AS_ERROR)
  ecbuild_add_cxx_flags("-Werror" NO_FAIL NAME pluto_cxx_warning_as_error QUIET)
endif()

ecbuild_add_option( FEATURE FORTRAN DESCRIPTION "Fortran API for pluto" )
if( HAVE_FORTRAN )
    ecbuild_enable_fortran( REQUIRED MODULE_DIRECTORY ${PROJECT_BINARY_DIR}/module )
endif()

include("cmake/pluto_hic_macros.cmake")

add_subdirectory(src)
add_subdirectory(examples)
add_subdirectory(tests)

ecbuild_install_project( NAME pluto )
ecbuild_print_summary()

=== src/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

if( atlas_HAVE_OMP_CXX )
  set( atlas_HAVE_OMP_CXX 1 )
else()
  set( atlas_HAVE_OMP_CXX 0 )
endif()

if( atlas_HAVE_OMP_Fortran )
  set( atlas_HAVE_OMP_Fortran 1 )
else()
  set( atlas_HAVE_OMP_Fortran 0 )
endif()

if( atlas_HAVE_TESSELATION )
  set( atlas_HAVE_TESSELATION 1 )
else()
  set( atlas_HAVE_TESSELATION 0 )
endif()

if( atlas_HAVE_QHULL )
  set( atlas_HAVE_QHULL 1 )
else()
  set( atlas_HAVE_QHULL 0 )
endif()

if( atlas_HAVE_CGAL )
  set( atlas_HAVE_CGAL 1 )
else()
  set( atlas_HAVE_CGAL 0 )
endif()

if( atlas_HAVE_PROJ )
  set( atlas_HAVE_PROJ 1 )
else()
  set( atlas_HAVE_PROJ 0 )
endif()

if( atlas_HAVE_FORTRAN )
  set( atlas_HAVE_FORTRAN 1 )
else()
  set( atlas_HAVE_FORTRAN 0 )
endif()

if( atlas_HAVE_ECTRANS )
  set( atlas_HAVE_ECTRANS 1 )
else()
  set( atlas_HAVE_ECTRANS 0 )
endif()

if( atlas_HAVE_PACKAGE_ECTRANS )
  set( atlas_HAVE_PACKAGE_ECTRANS 1 )
else()
  set( atlas_HAVE_PACKAGE_ECTRANS 0 )
endif()

if( atlas_HAVE_FFTW )
  set( atlas_HAVE_FFTW 1 )
else()
  set( atlas_HAVE_FFTW 0 )
endif()

if( atlas_HAVE_POCKETFFT )
  set( atlas_HAVE_POCKETFFT 1 )
else()
  set( atlas_HAVE_POCKETFFT 0 )
endif()

if( atlas_HAVE_BOUNDSCHECKING )
  set( atlas_HAVE_BOUNDSCHECKING 1 )
else()
  set( atlas_HAVE_BOUNDSCHECKING 0 )
endif()

if( atlas_HAVE_INIT_SNAN )
  set( atlas_HAVE_INIT_SNAN 1 )
else()
  set( atlas_HAVE_INIT_SNAN 0 )
endif()

if( atlas_HAVE_CUDA )
  set( atlas_HAVE_CUDA 1 )
else()
  set( atlas_HAVE_CUDA 0 )
endif()

if( atlas_HAVE_ACC )
  set( atlas_HAVE_ACC 1 )
else()
  set( atlas_HAVE_ACC 0 )
endif()

if( atlas_HAVE_GRIDTOOLS_STORAGE )
  set( atlas_HAVE_GRIDTOOLS_STORAGE 1 )
else()
  set( atlas_HAVE_GRIDTOOLS_STORAGE 0 )
endif()

set( atlas_BUILD_TYPE_RELEASE 0 )
set( atlas_BUILD_TYPE_DEBUG   0 )
if( CMAKE_BUILD_TYPE MATCHES "Release" )
  set( atlas_BUILD_TYPE_RELEASE 1 )
endif()
if( CMAKE_BUILD_TYPE MATCHES "Debug" )
  set( atlas_BUILD_TYPE_DEBUG 1 )
endif()

if( atlas_HAVE_ECKIT_DEVELOP )
  set( ATLAS_ECKIT_DEVELOP 1 )
else()
  set( ATLAS_ECKIT_DEVELOP 0 )
endif()

ecbuild_parse_version( ${eckit_VERSION} PREFIX ATLAS_ECKIT )
math( EXPR ATLAS_ECKIT_VERSION_INT "( 10000 * ${ATLAS_ECKIT_VERSION_MAJOR} ) + ( 100 * ${ATLAS_ECKIT_VERSION_MINOR} ) + ${ATLAS_ECKIT_VERSION_PATCH}" )

add_subdirectory( atlas_acc_support )

add_subdirectory( atlas )

if( atlas_HAVE_FORTRAN )
  if( atlas_HAVE_FCKIT_DEVELOP )
    set( ATLAS_FCKIT_DEVELOP 1 )
  else()
    set( ATLAS_FCKIT_DEVELOP 0 )
  endif()
  ecbuild_parse_version( ${fckit_VERSION} PREFIX ATLAS_FCKIT )
  math( EXPR ATLAS_FCKIT_VERSION_INT "( 10000 * ${ATLAS_FCKIT_VERSION_MAJOR} ) + ( 100 * ${ATLAS_FCKIT_VERSION_MINOR} ) + ${ATLAS_FCKIT_VERSION_PATCH}" )
 add_subdirectory( atlas_f )
endif()

add_subdirectory( apps )
add_subdirectory( tests )

if( HAVE_SANDBOX )
    add_subdirectory( sandbox )
endif()

=== hic/src/CMakeLists.txt ===
# (C) Copyright 2024- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

set(HIC_BACKEND_CUDA  0)
set(HIC_BACKEND_HIP   0)
set(HIC_BACKEND_DUMMY 0)
if( HAVE_CUDA )
  set(HIC_BACKEND_CUDA  1)
elseif( HAVE_HIP )
  set(HIC_BACKEND_HIP   1)
else()
  set(HIC_BACKEND_DUMMY 1)
endif()

configure_file(${PROJECT_SOURCE_DIR}/src/hic/hic_config.h.in ${PROJECT_BINARY_DIR}/src/hic/hic_config.h @ONLY )

ecbuild_add_library( TARGET hic
  TYPE INTERFACE
  PUBLIC_INCLUDES
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>
    $<INSTALL_INTERFACE:include>
)

ecbuild_add_library( TARGET hicsparse
  TYPE INTERFACE
  PUBLIC_INCLUDES
    $<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/src>
    $<BUILD_INTERFACE:${PROJECT_BINARY_DIR}/src>
    $<INSTALL_INTERFACE:include>
)

install( FILES ${PROJECT_BINARY_DIR}/src/hic/hic_config.h DESTINATION include/hic )
install( FILES hic/hic.h                                  DESTINATION include/hic )
install( FILES hic/hic_runtime.h                          DESTINATION include/hic )
install( FILES hic/hic_namespace_macro.h                  DESTINATION include/hic )
install( FILES hic/hic_library_types.h                    DESTINATION include/hic )
install( FILES hic/hicsparse.h                            DESTINATION include/hic )
install( FILES hic/hic_dummy/dummyShouldNotBeCalled.h     DESTINATION include/hic/hic_dummy )
install( FILES hic/hic_dummy/hic_dummy_runtime.h          DESTINATION include/hic/hic_dummy )
install( FILES hic/hic_dummy/hicsparse_dummy.h            DESTINATION include/hic/hic_dummy )

if( HAVE_CUDA )
  target_link_libraries( hic INTERFACE CUDA::cudart )
  target_link_libraries( hicsparse INTERFACE hic CUDA::cusparse )
elseif( HAVE_HIP )
  target_link_libraries( hic INTERFACE hip::host )
  target_link_libraries( hicsparse INTERFACE hic roc::hipsparse )
endif()

=== pluto/src/CMakeLists.txt ===
# (C) Copyright 2013- ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.


#pluto_host_device( pluto_host_device_src SOURCE pluto/device/MemoryResource.cc)

set(PLUTO_HAVE_CUDA ${HAVE_CUDA} )
set(PLUTO_HAVE_HIP  ${HAVE_HIP} )
set(PLUTO_HAVE_HIC  0)

if( HAVE_CUDA OR HAVE_HIP )
  set(PLUTO_HAVE_HIC 1)
endif()

configure_file(pluto/pluto_config.h.in pluto/pluto_config.h @ONLY )
install(
  FILES
    ${CMAKE_CURRENT_BINARY_DIR}/pluto/pluto_config.h
  DESTINATION
    ${INSTALL_INCLUDE_DIR}/pluto
)

if (NOT HAVE_PMR)
  list( APPEND pmr_compat_src
      pluto/memory_resource/compat/memory_resource
      pluto/memory_resource/compat/memory_resource.cc
  )
endif()

ecbuild_add_library( TARGET pluto
  SOURCES
    pluto/pluto.h
    ${CMAKE_CURRENT_BINARY_DIR}/pluto/pluto_config.h

    pluto/device/allocator.h
    pluto/device/MemoryResource.cc
    pluto/device/MemoryResource.h

    pluto/host/allocator.h
    pluto/host/MemoryResource.cc
    pluto/host/MemoryResource.h

    pluto/memory.cc
    pluto/memory.h
    pluto/memory_resource.h
    pluto/memory_resource/AsyncMemoryResourceAdaptor.cc
    pluto/memory_resource/AsyncMemoryResourceAdaptor.h
    pluto/memory_resource/DeviceMemoryResource.cc
    pluto/memory_resource/DeviceMemoryResource.h
    pluto/memory_resource/HostMemoryResource.cc
    pluto/memory_resource/HostMemoryResource.h
    pluto/memory_resource/ManagedMemoryResource.cc
    pluto/memory_resource/ManagedMemoryResource.h
    pluto/memory_resource/memory_resource.cc
    pluto/memory_resource/MemoryPoolResource.cc
    pluto/memory_resource/MemoryPoolResource.h
    pluto/memory_resource/MemoryResourceAdaptor.h
    pluto/memory_resource/PinnedMemoryResource.cc
    pluto/memory_resource/PinnedMemoryResource.h
    pluto/memory_resource/TraceMemoryResource.cc
    pluto/memory_resource/TraceMemoryResource.h
    pluto/memory_resource/detail/GatorMemoryResource.cc
    pluto/memory_resource/detail/GatorMemoryResource.h
    pluto/memory_resource/detail/yakl/YAKL_Gator.h
    pluto/memory_resource/detail/yakl/YAKL_LinearAllocator.h

    pluto/alignment.h
    pluto/copy.h
    pluto/event.cc
    pluto/event.h
    pluto/memcpy.cc
    pluto/memcpy.h
    pluto/pointer_info.cc
    pluto/pointer_info.h
    pluto/prefetch.cc
    pluto/prefetch.h
    pluto/runtime.cc
    pluto/runtime.h
    pluto/scope.cc
    pluto/scope.h
    pluto/stream.cc
    pluto/stream.h
    pluto/trace.cc
    pluto/trace.h
    pluto/wait.cc
    pluto/wait.h
    
    pluto/detail/Registry.h

    ${pmr_compat_src}
    pluto/mdspan.h
    pluto/detail/mdspan_paren_operator.h
    pluto/detail/mdspan/mdspan.hpp

  INSTALL_HEADERS ALL
  HEADER_DESTINATION include
  PUBLIC_LIBS hic
  PUBLIC_INCLUDES
      $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
      $<BUILD_INTERFACE:${CMAKE_CURRENT_BINARY_DIR}>
)

target_compile_features( pluto INTERFACE cxx_std_17 )
target_compile_options( pluto PUBLIC $<$<COMPILE_LANGUAGE:CUDA>:--extended-lambda>)

if (HAVE_FORTRAN)
  set(CMAKE_Fortran_MODULE_DIRECTORY ${CMAKE_BINARY_DIR}/module/pluto)
  ecbuild_add_library( TARGET pluto_f
    SOURCES
      pluto_f/pluto_module.F90
      pluto_f/pluto_module.cc
    PRIVATE_LIBS pluto
    PUBLIC_INCLUDES $<BUILD_INTERFACE:${CMAKE_Fortran_MODULE_DIRECTORY}>
                    $<INSTALL_INTERFACE:module/pluto>
  )
  if( ECBUILD_INSTALL_FORTRAN_MODULES )
    install( DIRECTORY ${CMAKE_BINARY_DIR}/module/pluto/
             DESTINATION module/pluto
             COMPONENT modules )
  endif()
endif()

=== src/atlas_acc_support/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

if( atlas_HAVE_ACC )

  if( CMAKE_CXX_COMPILER_ID MATCHES NVHPC )
    if( NOT TARGET OpenACC::OpenACC_CXX )
       ecbuild_error("ERROR: OpenACC::OpenACC_CXX TARGET not found")
    endif()
    ecbuild_add_library( TARGET atlas_acc_support SOURCES atlas_acc.cc )
    target_link_libraries( atlas_acc_support PRIVATE OpenACC::OpenACC_CXX )
  else()
    ecbuild_add_library( TARGET atlas_acc_support SOURCES atlas_acc.F90 )
    target_link_libraries( atlas_acc_support PRIVATE OpenACC::OpenACC_Fortran )
  endif()

endif()

=== src/atlas_f/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

configure_file( ${CMAKE_CURRENT_SOURCE_DIR}/atlas_f.h.in
                ${CMAKE_CURRENT_BINARY_DIR}/../atlas/atlas_f.h @ONLY )

execute_process( COMMAND ${CMAKE_COMMAND} -E create_symlink ${CMAKE_CURRENT_SOURCE_DIR}/atlas_f.fypp ${CMAKE_CURRENT_BINARY_DIR}/../atlas/atlas_f.fypp)

install( FILES
  ${CMAKE_CURRENT_SOURCE_DIR}/atlas_f.fypp
  ${CMAKE_CURRENT_BINARY_DIR}/../atlas/atlas_f.h
  DESTINATION
  ${INSTALL_INCLUDE_DIR}/atlas )


### fortran bindings

function(generate_fortran_bindings output filename)

  set( options "" )
  set( single_value_args OUTPUT MODULE )
  set( multi_value_args "" )
  cmake_parse_arguments( _PAR "${options}" "${single_value_args}" "${multi_value_args}"  ${_FIRST_ARG} ${ARGN} )

  get_filename_component(base ${filename} NAME_WE)
  set(base_abs ${CMAKE_CURRENT_SOURCE_DIR}/${base})
  set(outfile ${CMAKE_CURRENT_BINARY_DIR}/${base}_c_binding.f90)

  if( _PAR_OUTPUT )
    set(outfile ${_PAR_OUTPUT})
  endif()
  set(${output} ${${output}} ${outfile} PARENT_SCOPE)

  if( NOT _PAR_MODULE )
    set( _PAR_MODULE "atlas_${base}_c_binding" )
  endif()

  set( FINT32 "integer(c_int)"  )
  set( FINT64 "integer(c_long)" )
  set( F_GIDX ${FINT${ATLAS_BITS_GLOBAL}} )
  set( F_IDX ${FINT${ATLAS_BITS_LOCAL}} )

  add_custom_command(
    OUTPUT ${outfile}
    COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/tools/c2f.py ${CMAKE_CURRENT_SOURCE_DIR}/${filename}
            -o ${outfile} -m ${_PAR_MODULE}
            -t '{"idx_t":"${F_IDX}","gidx_t":"${F_GIDX}","atlas::idx_t":"${F_IDX}","atlas::gidx_t":"${F_GIDX}"}'
    DEPENDS ${filename} )
  set_source_files_properties(${outfile} PROPERTIES GENERATED TRUE)
endfunction()

generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/detail/grid/Grid.h
    MODULE    atlas_grid_Grid_c_binding
    OUTPUT    grid_Grid_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/detail/grid/CubedSphere.h
    MODULE    atlas_grid_CubedSphere_c_binding
    OUTPUT    grid_CubedSphere_c_binding.f90 )    
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/detail/grid/Structured.h
    MODULE    atlas_grid_Structured_c_binding
    OUTPUT    grid_Structured_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/detail/grid/Unstructured.h
    MODULE    atlas_grid_Unstructured_c_binding
    OUTPUT    grid_Unstructured_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/detail/distribution/DistributionImpl.h
    MODULE atlas_distribution_c_binding
    OUTPUT distribution_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/detail/vertical/VerticalInterface.h
    MODULE atlas_vertical_c_binding
    OUTPUT vertical_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/Partitioner.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/projection/detail/ProjectionImpl.h
    MODULE atlas_projection_c_binding
    OUTPUT projection_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/domain/detail/Domain.h
    MODULE atlas_domain_c_binding
    OUTPUT domain_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/detail/MeshIntf.h
    MODULE    atlas_mesh_c_binding
    OUTPUT    atlas_mesh_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/detail/MeshBuilderIntf.h
    MODULE    atlas_meshbuilder_c_binding
    OUTPUT    atlas_meshbuilder_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/Nodes.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/Connectivity.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/HybridElements.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/Elements.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/ElementType.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/actions/BuildParallelFields.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/actions/BuildPeriodicBoundaries.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/actions/BuildHalo.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/actions/BuildEdges.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/actions/BuildDualMesh.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/actions/BuildNode2CellConnectivity.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/mesh/actions/WriteLoadBalanceReport.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/meshgenerator/detail/MeshGeneratorInterface.h
    MODULE atlas_meshgenerator_c_binding
    OUTPUT meshgenerator_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/output/Output.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/output/detail/GmshInterface.h
  MODULE    atlas_output_gmsh_c_binding
  OUTPUT    output_Gmsh_c_binding.f90)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/field/State.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/field/detail/FieldInterface.h
    MODULE    atlas_field_c_binding
    OUTPUT    field_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/field/detail/MultiFieldInterface.h
    MODULE    atlas_multifield_c_binding
    OUTPUT    multifield_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/field/FieldSet.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/detail/FunctionSpaceInterface.h
    MODULE atlas_functionspace_c_binding
    OUTPUT functionspace_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/detail/SpectralInterface.h
    MODULE    atlas_functionspace_Spectral_c_binding
    OUTPUT    functionspace_Spectral_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/detail/StructuredColumnsInterface.h
    MODULE    atlas_functionspace_StructuredColumns_c_binding
    OUTPUT    functionspace_StructuredColumns_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/detail/BlockStructuredColumnsInterface.h
    MODULE    atlas_functionspace_BlockStructuredColumns_c_binding
    OUTPUT    functionspace_BlockStructuredColumns_c_binding.f90 )
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/detail/CellColumnsInterface.h
    MODULE    atlas_functionspace_CellColumns_c_binding
    OUTPUT    functionspace_CellColumns_c_binding.f90)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/detail/NodeColumnsInterface.h
    MODULE    atlas_functionspace_NodeColumns_c_binding
    OUTPUT    functionspace_NodeColumns_c_binding.f90)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/EdgeColumns.h
    MODULE    atlas_functionspace_EdgeColumns_c_binding
    OUTPUT    functionspace_EdgeColumns_c_binding.f90)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/functionspace/detail/PointCloudInterface.h
    MODULE    atlas_functionspace_PointCloud_c_binding
    OUTPUT    functionspace_PointCloud_c_binding.f90)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/redistribution/detail/RedistributionInterface.h
    MODULE    atlas_redistribution_c_binding
    OUTPUT    redistribution_c_binding.f90)

generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/grid/detail/grid/StencilComputerInterface.h
    MODULE    atlas_grid_StencilComputer_c_binding
    OUTPUT    grid_StencilComputer_c_binding.f90 )

if( atlas_HAVE_ATLAS_NUMERICS )
    generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/numerics/Nabla.h)
    generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/numerics/Nabla.h)
    generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/numerics/Method.h )
    generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/numerics/fvm/Method.h
        MODULE    atlas_fvm_method_c_binding
        OUTPUT    fvm_method_c_binding.f90 )
endif()

if( atlas_HAVE_ATLAS_INTERPOLATION )
    generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/interpolation/Interpolation.h
        MODULE    atlas_interpolation_c_binding
        OUTPUT    interpolation_c_binding.f90 )
endif()

if( atlas_HAVE_ATLAS_TRANS )
    generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/trans/detail/TransInterface.h
        MODULE    atlas_trans_c_binding
        OUTPUT    trans_c_binding.f90 )
endif()

generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/util/Allocate.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/util/Metadata.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/util/Config.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/util/Geometry.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/util/KDTree.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/output/detail/GmshIO.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/parallel/HaloExchange.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/parallel/GatherScatter.h)
generate_fortran_bindings(FORTRAN_BINDINGS ../atlas/parallel/Checksum.h)
generate_fortran_bindings(FORTRAN_BINDINGS internals/atlas_read_file.h)
generate_fortran_bindings(FORTRAN_BINDINGS internals/Library.h)
generate_fortran_bindings(FORTRAN_BINDINGS runtime/atlas_trace.h MODULE atlas_trace_c_binding OUTPUT atlas_trace_c_binding.f90 )


list( APPEND atlas_trans_srcs 
    trans/atlas_Trans_module.F90
)

list( APPEND atlas_interpolation_srcs 
    interpolation/atlas_Interpolation_module.F90
)

list( APPEND atlas_numerics_srcs 
    numerics/atlas_Method_module.F90
    numerics/atlas_fvm_module.F90
    numerics/atlas_Nabla_module.F90
)

if( NOT atlas_HAVE_ATLAS_TRANS )
    unset( atlas_trans_srcs )
endif()

if( NOT atlas_HAVE_ATLAS_INTERPOLATION )
    unset( atlas_interpolation_srcs )
endif()

if( NOT atlas_HAVE_ATLAS_NUMERICS )
    unset( atlas_numerics_srcs )
endif()


### atlas fortran lib
ecbuild_add_library( TARGET atlas_f
    AUTO_VERSION
    SOURCES
        ${FORTRAN_BINDINGS}
        atlas_module.F90
        util/atlas_functions_module.F90
        util/atlas_kinds_module.F90
        util/atlas_JSON_module.F90
        util/atlas_Config_module.F90
        util/atlas_Geometry_module.F90
        util/atlas_KDTree_module.F90
        util/atlas_Metadata_module.F90
        util/atlas_allocate_module.F90
        output/atlas_output_module.F90
        domain/atlas_Domain_module.F90
        functionspace/atlas_FunctionSpace_module.F90
        functionspace/atlas_functionspace_EdgeColumns_module.F90
        functionspace/atlas_functionspace_CellColumns_module.F90
        functionspace/atlas_functionspace_NodeColumns_module.fypp
        functionspace/atlas_functionspace_StructuredColumns_module.F90
        functionspace/atlas_functionspace_BlockStructuredColumns_module.F90
        functionspace/atlas_functionspace_Spectral_module.F90
        functionspace/atlas_functionspace_PointCloud_module.F90
        field/atlas_FieldSet_module.fypp
        field/atlas_State_module.F90
        field/atlas_Field_module.fypp
        field/atlas_MultiField_module.F90
        grid/atlas_Grid_module.F90
        grid/atlas_GridDistribution_module.F90
        grid/atlas_Vertical_module.F90
        grid/atlas_Partitioner_module.F90
        grid/atlas_StencilComputer_module.F90
        mesh/atlas_MeshBuilder_module.F90
        mesh/atlas_MeshGenerator_module.F90
        mesh/atlas_Mesh_module.F90
        mesh/atlas_mesh_Nodes_module.F90
        mesh/atlas_mesh_Edges_module.F90
        mesh/atlas_mesh_Cells_module.F90
        mesh/atlas_Connectivity_module.F90
        mesh/atlas_HybridElements_module.F90
        mesh/atlas_Elements_module.F90
        mesh/atlas_ElementType_module.F90
        mesh/atlas_mesh_actions_module.F90
        parallel/atlas_GatherScatter_module.fypp
        parallel/atlas_Checksum_module.fypp

=== doc/user-guide/core-functionalities/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

add_subdirectory(global-grids)
add_subdirectory(meshes)
add_subdirectory(fields)
add_subdirectory(functionspace)

=== pluto/tests/test_find_pluto/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.


# This test builds a package that requires fypp processing
# It uses the overriding of compile flags, like IFS is using.
#
# Test created to avoid regression after fixing issue FCKIT-19,
# where compile flags were not propagated to fypp-generated files.

if( HAVE_TESTS )
    
  configure_file( test.sh.in ${CMAKE_CURRENT_BINARY_DIR}/test.sh @ONLY )

  unset( _test_args )
  if( CMAKE_TOOLCHAIN_FILE )
    if( NOT IS_ABSOLUTE ${CMAKE_TOOLCHAIN_FILE})
        set( CMAKE_TOOLCHAIN_FILE "${CMAKE_BINARY_DIR}/${CMAKE_TOOLCHAIN_FILE}" )
    endif()
    list( APPEND _test_args "-DCMAKE_TOOLCHAIN_FILE=${CMAKE_TOOLCHAIN_FILE}" )
  endif()
  foreach( lang CXX )
    if( CMAKE_${lang}_COMPILER )
      list( APPEND _test_args "-DCMAKE_${lang}_COMPILER=${CMAKE_${lang}_COMPILER}" )
    endif()
    if( CMAKE_${lang}_FLAGS )
      list( APPEND _test_args "-DCMAKE_${lang}_FLAGS=${CMAKE_${lang}_FLAGS}" )
    endif()
  endforeach()

  add_test( NAME pluto_test_find_pluto
            COMMAND ${CMAKE_CURRENT_BINARY_DIR}/test.sh ${_test_args} )

endif()

=== src/apps/atlas-interpolations/CMakeLists.txt ===
# (C) Copyright 2025 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.


ecbuild_add_executable(
  TARGET  atlas-interpolations
  SOURCES atlas-interpolations.cc
          ScripIO.h
          ScripIO.cc
  LIBS    atlas
)

# Overcome Cray linking problem where the C++ library is not linked with the C library
list( APPEND NetCDF_CXX_EXTRA_LIBRARIES NetCDF::NetCDF_C )

ecbuild_add_option( FEATURE NETCDF
                    DESCRIPTION "Compile support the SCRIP format"
                    REQUIRED_PACKAGES "NetCDF COMPONENTS C CXX" )

target_compile_definitions( atlas-interpolations PRIVATE ATLAS_HAVE_NETCDF=${HAVE_NETCDF} )
if( HAVE_NETCDF )
  target_link_libraries( atlas-interpolations NetCDF::NetCDF_CXX )
endif()

function( atlas_test_app_atlas_interpolations case nprocs )

    string(REPLACE "/" ";" case ${case} )
    list( GET case 0 sgrid )
    list( GET case 1 tgrid )
    list( GET case 2 itype )
    unset( checksums )
    unset( case_tests )

    if( NOT DEFINED MPI_SLOTS )
      set( MPI_SLOTS 9999 )
    endif()

    foreach( n ${nprocs} )
      if ( (n EQUAL 0) OR eckit_HAVE_MPI )
        if( MPI_SLOTS GREATER_EQUAL ${n} )
            foreach( t 1 )
                set( case_name atlas_test_app_atlas_interpolations_${sgrid}_to_${tgrid}_with_${itype}_n${n}_t${t} )
                set( test_name ${case_name}_write )
                ecbuild_add_test( TARGET ${test_name}
                    COMMAND atlas-interpolations
                    ARGS    --display-name=${test_name}
                            --interpolate
                            --s.grid=${sgrid}
                            --t.grid=${tgrid}
                            --i.type=${itype}
                            --test-matrix
                            --output-matrix
                            --matrix.name=${case_name}
                            --matrix.format=eckit
                            --output-gmsh
                            --gmsh.coordinates=lonlat
                            --test-interpolator
                            --i.knn=4 # just in case itype==knn
                            --output-checksum
                            --checksum.file=${test_name}.checksum
                    MPI ${n}
                    OMP ${t}
                    ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
                )

                set( test_name ${case_name}_read )
                ecbuild_add_test( TARGET ${test_name}
                    COMMAND atlas-interpolations
                    ARGS    --display-name=${test_name}
                            --interpolate
                            --s.grid=${sgrid}
                            --t.grid=${tgrid}
                            --i.type=${itype}
                            --test-matrix
                            --read-matrix
                            --matrix.name=${case_name}
                            --matrix.format=eckit
                            --test-interpolator
                            --output-gmsh
                            --i.knn=4 # just in case itype==knn
                            --output-checksum
                            --checksum.file=${test_name}.checksum
                    MPI ${n}
                    OMP ${t}
                    ENVIRONMENT ${ATLAS_TEST_ENVIRONMENT}
                )
                set_tests_properties( ${case_name}_read PROPERTIES DEPENDS ${case_name}_write )

                # list( APPEND checksums ${test_name}.checksum )
                list( APPEND case_tests ${test_name} )
            endforeach()
        endif()
      endif()
    endforeach()
    # This kind of checksum test can be added, inspired from in tests/acceptance_tests/atlas_atest_mgrids
    # add_test(
    #     NAME atlas_test_app_atlas_interpolations_${sgrid}_to_${tgrid}_with_${itype}_BitReproducible
    #     COMMAND ${CMAKE_COMMAND}
    #     "-DFILES=${checksums}" -P ${CMAKE_CURRENT_SOURCE_DIR}/compare.cmake
    # )
    # foreach( dep ${case_tests} )
    #     set_tests_properties( atlas_test_app_atlas_interpolations_${sgrid}_to_${tgrid}__with_${itype}_BitReproducible PROPERTIES DEPENDS ${dep} )
    # endforeach()
endfunction()

if (HAVE_TESTS)
  unset(cases)
  list( APPEND cases
    O16/O32/finite-element
    O16/O32/structured-bilinear
    O16/O32/structured-bicubic
    O16/O32/knn

    O16/H32/finite-element
    O16/H32/structured-bilinear
    O16/H32/structured-bicubic
    O16/H32/knn

    H16/O32/finite-element
    H16/O32/structured-bilinear
    H16/O32/structured-bicubic
    H16/O32/knn

    H16/H32/finite-element
    H16/H32/structured-bilinear
    H16/H32/structured-bicubic
    H16/H32/knn
  )

  unset(nprocs)
  list( APPEND nprocs 0 8 )

  foreach( case ${cases} )
    atlas_test_app_atlas_interpolations( ${case} "${nprocs}" )
  endforeach()

  # Due to currently unknown halo requirements for conservative interpolation, we only do this in serial here

  unset(cases)
  list( APPEND cases
    O16/O32/cons
    O16/O32/cons2

    O16/H32/cons
    O16/H32/cons2

    H16/O32/cons
    H16/O32/cons2

    H16/H32/cons
    H16/H32/cons2
  )

  unset(nprocs)
  list( APPEND nprocs 0 )

  foreach( case ${cases} )
    atlas_test_app_atlas_interpolations( ${case} "${nprocs}" )
  endforeach()



endif()

=== src/sandbox/apps/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

ecbuild_add_executable(
  TARGET      atlas-loadbalance
  SOURCES     atlas-loadbalance.cc
  LIBS        atlas )

ecbuild_add_executable(
  TARGET      atlas-gmsh-extract
  SOURCES     atlas-gmsh-extract.cc
  LIBS        atlas )

ecbuild_add_executable(
  TARGET      atlas-benchmark
  SOURCES     atlas-benchmark.cc
  LIBS        atlas ${OMP_CXX}
)

ecbuild_add_executable(
  TARGET      atlas-numerics-nabla
  SOURCES     atlas-numerics-nabla.F90
  LIBS        atlas_f ${OMP_Fortran}
  LINKER_LANGUAGE Fortran
  CONDITION   HAVE_FORTRAN )

=== src/sandbox/fortran_acc_fields/CMakeLists.txt ===
# (C) Copyright 2013 ECMWF.
#
# This software is licensed under the terms of the Apache Licence Version 2.0
# which can be obtained at http://www.apache.org/licenses/LICENSE-2.0.
# In applying this licence, ECMWF does not waive the privileges and immunities
# granted to it by virtue of its status as an intergovernmental organisation nor
# does it submit to any jurisdiction.

if( atlas_HAVE_ACC ) 
    ecbuild_add_executable(
        TARGET  atlas-acc-fields
        SOURCES atlas-acc-fields.F90
        LIBS    atlas_f OpenACC::OpenACC_Fortran
        LINKER_LANGUAGE Fortran
        NOINSTALL
    )
endif()

=== debian/changelog ===
atlas-ecmwf (0.44.0-1) unstable; urgency=medium

  * New upstream release
  * Update minor version in links

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 10 Oct 2025 08:13:15 +0100

=== debian/control ===
Source: atlas-ecmwf
Section: science
Priority: optional
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders: Alastair McKinstry <mckinstry@debian.org>
Build-Depends: debhelper-compat (= 13), 
  dh-fortran-mod,
  ecbuild (>= 3.3.2),
  clang-tidy,
  chrpath,
  libfftw3-dev,
  libproj-dev,
  libjemalloc-dev,
  libqhull-dev,
  libopenmpi-dev,
  libboost-dev,
  python3-all-dev,
  libeckit-dev (>= 1.29.3),
  libfckit-dev (>= 0.12.1-2),
  libfckit-utils,
  libcgal-dev,
  librocsolver-dev [amd64 arm64 ppc64el],
  libhipblas-dev  [amd64 arm64 ppc64el],
  libhipfft-dev [amd64 arm64 ppc64el],
  librocfft-dev [amd64 arm64 ppc64el],
  libhipsparse-dev [arm64 amd64 ppc64el],
  hipcc [amd64 arm64 ppc64el],
  texlive-latex-base,
  texlive-latex-recommended,
  doxygen,
  doxygen-latex,
  libectrans-dev
Build-Conflicts: libatlas-ecmwf-dev,
  gfortran-13
Standards-Version: 4.7.2
Homepage: https://github.com/ecmwf/atlas
Vcs-Browser: https://salsa.debian.org/science-team/atlas-ecmwf.git
Vcs-Git: https://salsa.debian.org/science-team/atlas-ecmwf.git -b debian/latest

Package: libatlas-ecmwf-0
Section: libs
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Numerical weather prediction and climate modelling library
 Atlas is an ECMWF library for parallel data-structures supporting 
 unstructured grids and function spaces, with the aim to investigate
 alternative more scalable dynamical core options for Earth System models,
 and to support modern interpolation and product generation software.
 .
 Atlas is predominantly C++ code, with main features available to Fortran codes
 through a F2003 interface. 
 ECMWF is the European Centre for Medium-Range Weather Forecasts.


Package: libatlas-ecmwf-utils
Architecture: any
Multi-Arch: foreign
Depends:  ${shlibs:Depends}, ${misc:Depends}, libatlas-ecmwf-0 (= ${binary:Version}) 
Description: Numerical weather prediction and climate modelling library - utilities
 Atlas is an ECMWF library for parallel data-structures supporting 
 unstructured grids and function spaces, with the aim to investigate
 alternative more scalable dynamical core options for Earth System models,
 and to support modern interpolation and product generation software.
 .
 Atlas is predominantly C++ code, with main features available to Fortran codes
 through a F2003 interface. 
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

Package: libatlas-ecmwf-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Recommends: cmake, 
 pkgconf,
 ${fortran:Recommends}
Depends:  ${misc:Depends},
 ${fortran:Depends},
 libatlas-ecmwf-0 (= ${binary:Version}),
 libatlas-ecmwf-utils (= ${binary:Version}),
 libeckit-dev,
 libcgal-dev,
 libeigen3-dev, 
 libjemalloc-dev,
 libfckit-dev
Description: Numerical weather prediction and climate modelling library - dev files
 Atlas is an ECMWF library for parallel data-structures supporting 
 unstructured grids and function spaces, with the aim to investigate
 alternative more scalable dynamical core options for Earth System models,
 and to support modern interpolation and product generation software.
 .
 Atlas is predominantly C++ code, with main features available to Fortran codes
 through a F2003 interface. 
 ECMWF is the European Centre for Medium-Range Weather Forecasts.

=== debian/rules ===
#!/usr/bin/make -f

export DH_VERBOSE=1

DPKG_EXPORT_BUILDFLAGS=1

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
LIBDIR:=/usr/lib/$(DEB_HOST_MULTIARCH)
INCDIR:=/usr/include/$(DEB_HOST_MULTIARCH)
INSTDIR:=$(CURDIR)/debian/tmp
CMAKE_DIR:=$(INSTDIR)/$(LIBDIR)/cmake

include /usr/share/debhelper/dh-fortran/fortran-support.mk
FMODDIR:=$(call get_fmoddir,$(FC_DEFAULT))

export HIPCXX=clang++

#export HIP_PLATFORM=amd
#export HIP_RUNTIME=rocclr
#export HIP_COMPILER=clang
#export HIP_CLANG_PATH=/usr/bin
#export DEVICE_LIB_PATH=/usr/lib64/amdgcn/bitcode
#export HIP_DEVICE_LIB_PATH=/usr/lib64/amdgcn/bitcode
#export HSA_PATH=/usr/hsa
#export LLVM_PATH=/usr

ARCH_HIP:= amd64 arm64 ppc64el
ENABLE_HIP:= $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_HIP)),On,Off)
# HIP options thanks to Cory Bloor: match the math libs ectrans depends on
ENABLE_HIP:= Off

CXXFLAGS := $(shell dpkg-buildflags --get CXXFLAGS) -I$(CURDIR)/src -I$(CURDIR)/debian/build/src -I$(CURDIR)/atlas_io/src -I$(CURDIR)/hic/src -I$(CURDIR)/debian/build/hic/src -I$(CURDIR)/pluto/src -I$(CURDIR)/debian/build/pluto/src

FCFLAGS:= $(shell dpkg-buildflags --get FCFLAGS) -I$(FMODDIR) -I$(FMODDIR)/fckit

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildflags.mk

# Strange bug with omp.h headers and clang-tidy on some archs
ARCH_CLANG_TIDY_OFF:= s390x mipsel
ENABLE_CLANG_TIDY:= $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_CLANG_TIDY_OFF)),Off,On)

# Override in 0.27.0 build - causes failures on mixed g++/clang environments
ENABLE_CLANG_TIDY:= Off

# OMP Doesn't appear to work on these archs
ARCH_NO_OMP:= riscv64 sparc64
ENABLE_OMP:=  $(if $(filter $(DEB_TARGET_ARCH), $(ARCH_NO_OMP)),Off,On)

BUILD_FLAGS = \
        -DCMAKE_CXX_FLAGS="$(CXXFLAGS) " \
	-DCMAKE_Fortran_FLAGS="$(FCFLAGS) " \
P	-DENABLE_DOCS=On \
	-DENABLE_CXX17=On \
	-DENABLE_CLANG_TIDY=$(ENABLE_CLANG_TIDY) \
	-DENABLE_GRIDTOOLS_STORAGE=Off  \
	-DENABLE_TESSELATION=On \
	-DENABLE_CGAL=On \
	-DENABLE_ECTRANS=On \
	-DENABLE_OMP=$(ENABLE_OMP) \
	-DENABLE_FORTRAN=On \
	-DENABLE_ACC=On \
	-Datlas_FULL_INSTALL_CMAKE_DIR=$(LIBDIR)/cmake/atlas_ecmwf \
	-DENABLE_INIT_SNAN=On \
	-DENABLE_PROJ=On \
	-DENABLE_HIP=$(ENABLE_HIP) \
	-DENABLE_ECKIT_CODEC=On \
	-DENABLE_HIP=$(ENABLE_HIP) \
	-DCMAKE_HIP_COMPILER_ROCM_LIB=$(LIBDIR) \
	-DCMAKE_HIP_ARCHITECTURES="gfx803;gfx900;gfx906;gfx908;gfx90a;gfx1010;gfx1030;gfx1100;gfx1101;gfx1102"

# Test suite requires 4 processors. Fake it
export OMPI_MCA_rmaps_base_oversubscribe=1

%:
	LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh $@ --buildsystem=ecbuild --builddir=debian/build --with fortran_mod

override_dh_auto_configure:
	LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_configure -- ${BUILD_FLAGS} 

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	#LD_LIBRARY_PATH=$(CURDIR)/debian/build/lib dh_auto_test 
	echo "Ignore tests this build"
endif

override_dh_auto_install:
	dh_auto_install
	mkdir -p $(INSTDIR)/$(LIBDIR)/pkgconfig
	chrpath -d $(INSTDIR)/usr/bin/*
	chrpath -d $(INSTDIR)/$(LIBDIR)/*.so*
	# rename 
	mv $(CMAKE_DIR)/atlas $(CMAKE_DIR)/atlas_ecmwf
	#for d in atlas-config.cmake  atlas-config-version.cmake  atlas-import.cmake  atlas-targets.cmake  atlas-targets-release.cmake ; do \
	#	n=`echo $$d | sed -e 's/atlas/atlas_ecmwf/' ` ; \
	#	mv $(CMAKE_DIR)/atlas_ecmwf/$$d $(CMAKE_DIR)/atlas_ecmwf/$$n ; done
	# Fix broken paths
	sed -i -e 's%$${CURDIR}%/build/atlas-ecmwf%g' \
	       -e 's%/cmake/atlas"%/cmake/atlas_ecmwf"%g' \
	       -e 's%atlas-%atlas_ecmwf-%g'               $(CMAKE_DIR)/atlas_ecmwf/atlas-config.cmake
	sed -i -e 's%/cmake/atlas"%/cmake/atlas_ecmwf"%g' \
	       -e 's%$${CURDIR}%/build/atlas-ecmwf%g'     \
	       -e 's%atlas-targets%atlas_ecmwf-targets%g' \
	       -e 's%include/atlas%include/${DEB_HOST_MULTIARCH}/atlas%g'  $(CMAKE_DIR)/atlas_ecmwf/atlas-targets.cmake
